/* zsban
scan.l -- lex szabalyok az egyszeru parserhez

Nyelvi tbbrtelmsg: az, hogy egy karra "mutats", az kt dolgot
is jelenthet.

Dokut lasd a scan.cxx-ben

*/

%{

#include "scan.hh"
#include <cstdlib>
#include <cerrno>
#include <iostream>
#include <string>

using std::cout;
using std::cerr;


long tokenval_n;
string tokenval_s;


%}


%option noyywrap

id	[[:alpha:]_][[:alnum:]_]*


%%

\n	{
	if (interactive&INTERA_NL)
		return T_NL;
	else
		if (interactive&INTERA_TTY)
			cout <<"> ";
	}
[[:space:]]	;
#.*	;
[0-9]+	{
	errno= 0;
	tokenval_n= strtol (yytext, 0, 10);
	if (errno)
		fatal ("parse error: integer literal overflow");
	return T_INT;
	}
{id}	{
	tokenval_s= yytext;
	return T_ID;
	}
;	return T_SC;
,	return T_COMMA;
=	return T_LET;
\(	return T_OPEN;
\)	return T_CLOSE;
\{	return T_BOPEN;
\}	return T_BCLOSE;
\+	return T_PLUS;
-	return T_MINUS;
\*	return T_STAR;
\/	return T_SLASH;
%	return T_PERCENT;
\+=	return T_PLUSLET;
-=	return T_MINUSLET;
\*=	return T_STARLET;
\/=	return T_SLASHLET;
%=	return T_PERCENTLET;
==	return T_EQ;
\<	return T_LT;
\>	return T_GT;
\<\>	return T_NE;
\<=	return T_LE;
\>=	return T_GE;
\^	return T_HAT;
&&	return T_AMPAMP;
\|\|	return T_BARBAR;
::	return T_COLONCOLON;
\?\?	return T_QUESQUES;
!!	return T_BANGBANG;
:	return T_COLON;
\?	return T_QUES;
!	return T_BANG;


[[:print:]]	{ 
	cerr <<"parse error: illegal character: '" <<*yytext; 
	fatal ("'"); 
	}
.	{ 
	cerr <<"parse error: illegal character: 0" 
		<<std::oct <<(int)(unsigned char)(*yytext) ; 
	fatal (""); 
	}

%%






/*__END__*/
